<?php
/**
* Языковый файл
* 
* @author Igor Ognichenko
* @copyright Copyright (c)2007-2009 by Kasseler CMS
* @link http://www.kr-cms.net/
* @version 2.0
*/
if (!defined('FUNC_FILE')) die('Access is limited');

$lang = array(
    'google_search'                 => 'Поиск Google',
    'yandex_search'                 => 'Поиск Yandex',
    'adm_blocks'                    => 'Блоки и баннеры',
    'management'                    => 'Управление',
    'access_rights'                 => 'Права доступа',
    'security'                      => 'Безопасность',
    'statistic'                     => 'Статистика',
    'server_info'                   => 'Информация о сервере',
    'modules'                       => 'Модули',
    'help'                          => 'Помощь',
    'version_check'                 => 'Проверить обновления',
    'phpinfo'                       => 'Информация о сервере',
    'admin_login'                   => 'Авторизация администратора',
    'total'                         => 'Общие',
    'config'                        => 'Конфигурация',
    'database'                      => 'База данных',
    'confmail'                      => 'Рассылки',
    'home_title'                    => 'Название сайта',
    'home_title_d'                  => 'Например: "Мой сайт"',
    'http_home_url'                 => 'Адрес сайта',
    'http_home_url_d'               => 'Например: http://yoursite.net/',
    'charset'                       => 'Используемая кодировка на сайте',
    'charset_d'                     => 'Укажите кодировку, которую использует ваш сайт. Например: windows-2151',
    'description'                   => 'Описание сайта (description)',
    'description_d'                 => 'Краткое описание, не более 200 символов',
    'keywords'                      => 'Ключевые слова сайта (keywords)',
    'keywords_d'                    => 'Введите через запятую основные ключевые слова для вашего сайта',
    'GMT_correct'                   => 'Коррекция временной зоны',
    'GMT_correct_d'                 => 'в часах. Например: 3 (плюс три часа), -2 (минус два часа)',
    'rewrite'                       => 'Включить ЧПУ',
    'rewrite_d'                     => 'ЧПУ - Человеку Понятный Урл. Если да то все ссылки будут в виде псевдо URL. Например: http://yoursite.net/name_news',
    'separator_rewrite'             => 'Разделитель ЧПУ',
    'separator_rewrite_d'           => 'Символ который будет разделять переменные URL. Например:  если "-" http://yoursite.net/news-name_news',
    'file_rewrite'                  => 'Окончание ЧПУ ссылки',
    'file_rewrite_d'                => 'Файловое окончание URL. Например:  если ".asp"<br />http://yoursite.net/news-name_news.asp',
    'separator'                     => 'Разделитель заголовка',
    'separator_d'                   => 'Например: если "|"  то заголовок страницы будет выгладить так "Первая новость | Новости @ Мой сайт"',
    'sitelogo'                      => 'Логотип сайта',
    'sitelogo_d'                    => 'Например: includes/images/logos/1.png',
    'user_cookies'                  => 'Название COOKIES для администраторов',
    'admin_cookies'                 => 'Название COOKIES для пользователей',
    'user_cookies_d'                => 'Название COOKIES которые будут сохранятся у пользователей',
    'admin_cookies_d'               => 'Название COOKIES которые будут сохранятся у администраторов',
    'adm_language'                  => 'Используемый язык',
    'language_d'                    => 'Выберите язык, который будет использоваться по умолчанию',
    'template_d'                    => 'Выберите шаблон, который будет использоваться по умолчанию',
    'default_module'                => 'Загружаемый модуль на главной',
    'default_module_d'              => 'Выберете модуль которые будет отображаться на главной сайта',
    'case_template'                 => 'Разрешить пользователям выбор шаблонов',
    'case_template_d'               => 'При отключении данной опции пользователи принудительно будут использовать шаблон выбранный в админ панели',
    'disable_site'                  => 'Выключить сайт',
    'disable_site_d'                => 'Перевести сайт в состояние offline, для проведения технических работ',
    'disable_description'           => 'Причина отключения сайта',
    'disable_description_d'         => 'Сообщение для отображения в режиме отключенного сайта. Разрешается HTML',
    'smiles'                        => 'Смайлики',
    'smile'                         => 'Смайлик',
    'smile_code'                    => 'Код',
    'undefined'                     => 'Неизвестно',
    'mode_on'                       => 'Включен',
    'mode_off'                      => 'Выключен',
    'serverinfo'                    => 'Информация о сервере',
    'systeminfo'                    => 'Информация о системе',
    'licence'                       => 'Лицензия',
    'status_site'                   => 'Статус сайта',
    'rewrite_status'                => 'ЧПУ',
    'gzip'                          => 'gZip',
    'gzip_level'                    => 'Уровень сжатия',
    'def_template'                  => 'Шаблон',
    'addnews'                       => 'Добавить новость',
    'desc_news'                     => 'Модуль создания и ведения новостей на Вашем сайте.',
    'desc_faq'                      => 'Модуль сервиса Вопросов и Ответов на Вашем сайте.',
    'desc_files'                    => 'Модуль для хранения файлов в электронном виде.',
    'desc_jokes'                    => 'Юмористический модуль для публикации анекдотов.',
    'desc_media'                    => 'Модуль для ведения каталога Media файлов.',
    'desc_topsite'                  => 'Модуль рейтинга сайтов партнеров.',
    'sortas'                        => 'Сортировка по',
    'asdate'                        => 'По дате',
    'astitle'                       => 'По названию',
    'asstatus'                      => 'По статусу',
    'asname'                        => 'По имени',
    'asregdate'                     => 'По дате регистрации',
    'aslastvisit'                   => 'По дате последнего визита',
    'methoddown'                    => 'По убыванию',
    'methodup'                      => 'По возрастанию',
    'directory'                     => 'Каталог для файлов',
    'attaching_files_type'          => 'Типы загружаемых файлов',
    'miniature_image_width'         => 'Максимальная ширина миниатюры',
    'miniature_image_height'        => 'Максимальная высота миниатюры',
    'max_image_width'               => 'Максимальная ширина изображения',
    'max_image_height'              => 'Максимальная высота изображения',
    'attaching_files_size'          => 'Максимальный размер',
    'file_upload_limit'             => 'Лимит прикрепляемых файлов',
    'publications_in_page'          => 'Количество публикаций на страницу',
    'sort_type_publications'        => 'Метод сортировки',
    'sort_publications'             => 'Тип сортировки',
    'comments_sort'                 => 'Метод сортировки комментариев',
    'rss_title'                     => 'Заголовок RSS канала',
    'rss_limit'                     => 'Количество публикаций в RSS канале',
    'conf_rss'                      => 'Активировать RSS',
    'attaching'                     => 'Разрешить прикрепление файлов',
    'list_publications'             => 'Активировать список публикаций',
    'conf_categories'               => 'Активировать список категорий',
    'multiple_cat'                  => 'Разрешить мульти-категории',
    'ratings'                       => 'Активировать рейтинги',
    'guests_evaluate'               => 'Активировать рейтинги для гостей',
    'conf_comments'                 => 'Разрешить комментарии',
    'guests_comments'               => 'Разрешить комментарии для гостей',
    'similar_publications'          => 'Активировать список схожих публикаций',
    'moderation_publications'       => 'Модерировать новые публикации',
    'comments_publishing'           => 'Разрешить акт./деакт. комментариев при публикации',
    'publications_users'            => 'Разрешить создание публикаций для пользователей',
    'publications_guest'            => 'Разрешить создание публикаций для гостей',
    'conf_page_break'               => 'Разрешить разрыв страницы при публикации',
    'directory_d'                   => 'Директория для хранения прикрепленных файлов',
    'attaching_files_type_d'        => 'Допустимые разрешения для загрузки файлов',
    'miniature_image_width_d'       => 'Ширина уменьшенной копии изображения (пиксели)',
    'miniature_image_height_d'      => 'Высота уменьшенной копии изображения (пиксели)',
    'max_image_width_d'             => 'Предельно допустимая ширина загружаемого изображения (пиксели)',
    'max_image_height_d'            => 'Предельно допустимая высота загружаемого изображения (пиксели)',
    'attaching_files_size_d'        => 'Предельно допустимый размер загружаемого файла (Kb)',
    'file_upload_limit_d'           => 'Максимальное количество прикреплений к одной публикации',
    'publications_in_page_d'        => 'Количество выводимых публикаций на одну станицу',
    'sort_type_publications_d'      => 'Тип сортировки публикации по убыванию/по возрастанию',
    'sort_publications_d'           => 'Параметр для сортировки публикаций',
    'comments_sort_d'               => 'Тип сортировки комментариев по убыванию/по возрастанию',
    'rss_title_d'                   => 'Название RSS канала (так как будет отображаться в ленте) ',
    'rss_limit_d'                   => 'Количество публикаций которое пользователь получит при загрузке канала',
    'conf_rss_d'                    => 'Разрешить RSS канал',
    'attaching_d'                   => 'Разрешить пользователям прикреплять файлы к публикациям',
    'list_publications_d'           => 'Разрешить страницу списка публикаций',
    'conf_categories_d'             => 'Разрешить страницу списка категорий',
    'multiple_cat_d'                => 'Разрешить множественный выбор категорий для публикаций',
    'ratings_d'                     => 'Разрешить рейтинг для публикаций',
    'guests_evaluate_d'             => 'Разрешить гостям участвовать в рейтинге публикаций',
    'conf_comments_d'               => 'Активировать комментарии к публикациям',
    'guests_comments_d'             => 'Активировать комментарии для гостей',
    'similar_publications_d'        => 'Выводить блок всех схожих публикаций',
    'moderation_publications_d'     => 'Включение/отключение  модерирования публикаций',
    'comments_publishing_d'         => 'Пользователи смогут отключать комментарии для своих публикаций',
    'publications_users_d'          => 'Активировать  страницу публикации для пользователей',
    'publications_guest_d'          => 'Активировать  страницу публикации для гостей',
    'conf_page_break_d'             => 'Активировать многостраничные публикации',
    'text_smile'                    => 'Текстовое значение',
    'url_smile'                     => 'URL изображения',
    'tools'                         => 'Инструменты',
    'filemanager'                   => 'Файловый менеджер',
    'categories_ico'                => 'Активировать иконки категорий',
    'categories_desc'               => 'Активировать описание категорий',
    'categories_ico_d'              => 'Отображать иконки категорий при их выводе',
    'categories_desc_d'             => 'Отображать описание категорий при их выводе',
    'sataus_f'                      => 'Активировать/деактивировать выделенное',
    'delete_f'                      => 'Удалить выделенное',
    'weight'                        => 'Положение',
    'position'                      => 'Позиция',
    'who_views'                     => 'Кто видит',
    'top_baner'                     => 'Верхний баннер',
    'top_block'                     => 'По центру вверху',
    'left_block'                    => 'Слева',
    'right_block'                   => 'Справа',
    'bottom_block'                  => 'По центру внизу',
    'bottom_baner'                  => 'Нижний баннер',
    'alluser'                       => 'Все',
    'onlyguest'                     => 'Только гости',
    'onlyuser'                      => 'Только пользователи',
    'onlyadmin'                     => 'Только администраторы',
    'on'                            => '<span style="color: green;">Вкл.</span>',
    'off'                           => '<span style="color: red;">Выкл.</span>',
    'moderation'                    => '<span style="color: #2673CC;">На модерации</span>',
    'move_up'                       => 'Переместить вверх',
    'move_down'                     => 'Переместить вниз',
    'add_block'                     => 'Добавить блок',
    'create_block'                  => 'Создать блок',
    'admin_block'                   => 'Управление блоками',
    'php_code'                      => 'PHP код нового блока',
    'show_module'                   => 'Отображать блок в модулях',
    'create_news'                   => 'Создать новость',
    'configuratin'                  => 'Конфигурации',
    'further'                       => 'Дополнительно',
    'patterns_text'                 => 'Тексты',
    'message_registration'          => 'Шаблон сообщения о регистрации на сайте',
    'pat_activation_user'           => 'Шаблон запроса активации пользователя',
    'message_registration_d'        => 'Сообщение, которое будет отправлено после удачной регистрации на сайте<br />{SITE} - ссылка на сайт<br />{USER} - логин пользователя<br />{PASSWORD} - пароль пользователя',
    'activation_user_d'             => 'Сообщение запроса подтверждения e-mail адреса.<br />{SITE} - ссылка на сайт<br />{USER} - логин пользователя<br />{EMAIL} - E-mail получателя<br />{CODE} - код активации пользователя',
    'adminfile'                     => 'Файл админпанели',
    'adminfile_d'                   => 'Вы можете изменить имя файла админпанели. По умолчанию это admin.php, если вы указываете новый файл, то не забудьте переименовать его на сервере.',
    'logined_admin'                 => 'Метод авторизации в админпанели',
    'logined_admin_d'               => 'При включении расширенного метода авторизации в админпанели, каждая новая сессия в администратора будет требовать повторного ввода пароля, что гарантирует невозможность входа в админпанель, в случае кражи ваших Cookies.',
    'standart_method'               => 'Стандартный метод',
    'specify_method'                => 'Расширенный метод',
    'admin_mail'                    => 'E-mail адрес администратора',
    'admin_mail_d'                  => 'Введите E-mail адрес администратора сайта',
    'send_mail'                     => 'Включить отправку E-mail',
    'send_mail_d'                   => 'Активировать функцию send_mail()',
    'serverbd'                      => 'Сервер БД',
    'userbd'                        => 'Пользователь БД',
    'passwordbd'                    => 'Пароль пользователя БД',
    'namebd'                        => 'Название БД',
    'prefixbd'                      => 'Префикс БД',
    'typebd'                        => 'Тип СУБД',
    'charsetbd'                     => 'Кодировка БД',
    'serverbd_d'                    => 'Укажите адрес базы данных',
    'userbd_d'                      => 'Введите пользователя базы данных<br />Пример: root',
    'passwordbd_d'                  => 'Пароль пользователя базы данных',
    'namebd_d'                      => 'Название вашей базы данных',
    'prefixbd_d'                    => 'Префикс таблиц в вашей базе данных',
    'typebd_d'                      => 'Выберете используемую СУБД',
    'charsetbd_d'                   => 'Кодировка базы данных<br />Пример: cp1251',
    'cachebd'                       => 'Кэшировать запросы СУБД',
    'cachebd_d'                     => 'Кэширование запросов значительно уменьшает количество обращений к серверу базы данных',
    'sql_cache_clear'               => 'Условия очистки кэша',
    'sql_cache_clear_d'             => 'SQL функции при выполнении которых кэш будет очищен',
    'no_cache_tables'               => 'Не кэшируемые таблицы',
    'no_cache_tables_d'             => 'Список таблиц через запятую запросы к которым не будут кэшироваться',
    'capcha_symbols'                => 'Список выводимых символов',
    'capcha_count_symbols'          => 'Количество выводимых символов',
    'capcha_symbols_d'              => 'Символы, выводимые в коде безопасности',
    'capcha_count_symbols_d'        => 'Количество выводимых символов в коде безопасности. Например: 3-5, от 3 до 5 символов',
    'ajaxload'                      => 'Активировать AJAX навигацию по сайту',
    'ajaxload_d'                    => 'Включение или отключение перехода по страницами, при помощи AJAX. Технология AJAX значительно уменьшает количество запросов к БД',
    'geoip'                         => 'Определение региона',
    'geoip_d'                       => 'Даная опция позволяет определять страну пользователя',
    'gz'                            => 'Активировать сжатие gZip',
    'gz_d'                          => 'Данная опция позволяет существенно сжать выход сгенерированного кода',
    'gzlevel'                       => 'Степень gZip сжатия',
    'gzlevel_d'                     => 'Уровень сжатия. Рекомендованный уровень 5',
    'date_format'                   => 'Формат даты <a href=\'#\' onclick=\"newWindow = window_open(\'/includes/docs/date.html\', \'\', \'toolbar=0,width=720,height=600,resizable=0,menubar=0,scrollbars=1,status=0\'); return false;\">[&#191;]</a>"',
    'date_format_d'                 => 'Выводимый формат даты на сайте',
    'classes_links'                 => 'Классы AJAX ссылок',
    'classes_links_d'               => 'Ссылки с указанными классами будут автоматически преобразованы на AJAX навигацию по сайту',
    'interval_session_update'       => 'Интервал обновления сессии',
    'interval_session_update_d'     => 'Промежуток времени в секундах через который сессия пользователя будет обновляться',
    'time_online'                   => 'Время работы сессий',
    'time_online_d'                 => 'Время сессии в секундах, по истечении заданного времени пользователь будет считаться ушедшим с сайта',
    'time_of_life_session'          => 'Время сохранения COOKIES',
    'time_of_life_session_d'        => 'Промежуток времени, в днях, будет сохранятся авторизация на сайте',
    'editor_conf'                   => 'Редактор',
    'dewlope'                       => 'Разработка',
    'rss_chenal'                    => 'RSS каналы',
    'mark1'                         => 'нижний правый угол',
    'mark2'                         => 'верхний правый угол',
    'mark3'                         => 'нижний левый угол',
    'mark4'                         => 'верхний левый угол',
    'mark5'                         => 'по центру',
    'textarea_editor'               => 'Обычный textarea',
    'bb_editor'                     => 'BB редактор',
    'mark_img'                      => 'Изображение водяного знака',
    'mark'                          => 'Включить водяные знаки',
    'htmlTags'                      => 'Список разрешенных HTML тегов',
    'typeEditor'                    => 'Тип текстового редактора',
    'mark_img_d'                    => 'Укажите изображение водяного знака, от корня сайта',
    'mark_d'                        => 'Выберете положение водяного знака',
    'htmlTags_d'                    => 'Список HTML тегов которые не фильтруются',
    'typeEditor_d'                  => 'Выберите тип редактора для публикаций',
    'allusers'                      => 'Все пользователи',
    'off2'                          => 'Отключить',
    'query'                         => 'Включить анализатор запросов к БД',
    'variables'                     => 'Включить анализатор переменных',
    'mode_debugging_php'            => 'Включить вывод PHP ошибок',
    'mode_debugging_http'           => 'Включить вывод HTTP ошибок',
    'mode_debugging_sql'            => 'Включить вывод SQL ошибок',
    'log_debugging_php'             => 'Включить log PHP ошибок',
    'log_debugging_sql'             => 'Включить log SQL ошибок',
    'log_debugging_http'            => 'Включить log HTTP ошибок',
    'log_error_user_logined'        => 'Включить log авторизаций',
    'query_d'                       => 'Кто будет видеть анализатор запросов к БД',
    'variables_d'                   => 'Кто будет видеть анализатор переменных',
    'mode_debugging_php_d'          => 'Активировать страницу отладки PHP ошибок',
    'mode_debugging_http_d'         => 'Активировать страницу отладки HTTP ошибок',
    'mode_debugging_sql_d'          => 'Активировать страницу отладки SQL ошибок',
    'log_debugging_php_d'           => 'Активировать запись в файл всех возникших PHP ошибок',
    'log_debugging_sql_d'           => 'Активировать запись в файл всех возникших SQL ошибок',
    'log_debugging_http_d'          => 'Активировать запись в файл всех возникших HTTP ошибок',
    'log_error_user_logined_d'      => 'Активировать запись в файл всех неудачных авторизаций',
    'monitoring'                    => 'Наблюдение админ.',    
    'lastpublications'              => 'Новые публикации',
    'newsites'                      => 'Новые сайты',
    'newjokes'                      => 'Новые анекдоты',
    'newfiles'                      => 'Новые файлы',
    'newmedia'                      => 'Новые медиа',
    'newnews'                       => 'Новые новости',
    'dbsize'                        => 'Размер БД',
    'tablesdb'                      => 'Таблиц в БД',
    'rowsdb'                        => 'Записей в БД',
    'charsetdb'                     => 'Кодировка таблиц',
    'allsites'                      => 'Всего сайтов',
    'alljokes'                      => 'Всего анекдотов',
    'allfiles'                      => 'Всего файлов',
    'allmedia'                      => 'Всего медиа',
    'allnews'                       => 'Всего новостей',
    'stat_database'                 => 'Базы данных',
    'stat_newpub'                   => 'Новые публикации',
    'stat_allpub'                   => 'Всего публикаций',
    'stat_user'                     => 'Пользователи',
    'stat_alluser'                  => 'Всего пользователей',
    'nocativeuser'                  => 'Неактивных пользователей',
    'sevendaysreg'                  => 'Новых пользователей за неделю',
    '30daysreg'                     => 'Новых пользователей за месяц',
    'visittoday'                    => 'Пользователей посетивших за сутки',
    'stat_filesystem'               => 'Файловая система',
    'cachesize'                     => 'Размер кэша',
    'cachefiles'                    => 'Количество файлов кэша',
    'cachesizesql'                  => 'Размер SQL кэша',
    'cachefilessql'                 => 'Количество файлов SQL кэша',
    'logsize'                       => 'Размер log файлов',
    'freespase'                     => 'Свободно места на диске',
    'stat_forum'                    => 'Форум',
    'stat_cats'                     => 'Создано форумов',
    'stat_topics'                   => 'Создано тем',
    'stat_posts'                    => 'Оставлено сообщений',
    'sendmail'                      => 'Рассылка',
    'categories'                    => 'Категории',
    'add_cat'                       => 'Добавить категорию',
    'add_cubcat'                    => 'Добавить подкатегорию',
    'yes'                           => 'Есть',
    'subcat'                        => 'Подкатегория',
    'yes2'                          => 'Да',
    'level'                         => 'Уровень',
    'main_cat'                      => 'Корневая категория',
    'description2'                  => 'Описание',
    'preview'                       => 'Предварительный просмотр',
    'cat_title_err'                 => '<li class="error">Не введено название категории!</li>',
    'module_err'                    => '<li class="error">Не выбран модуль категории!</li>',
    'cat_case_error'                => '<li class="error">Не выбрана родительская категория!</li>',
    'title_mess_err'                => '<li class="error">Не введен заголовок сообщения!</li>',
    'case_module'                   => '-=Выберите модуль=-',
    'case_cat'                      => '-=Выберите родительскую категорию=-',
    'groups_sends'                  => 'Отправить группам',
    'desc_send_meil'                => '{USER} – имя пользователя<br />{EMAIL} – E-mail пользователя<br />{SITE} – ссылка на сайт',
    'desc_case_group'               => 'Выберите группы, которые получат письмо',
    'admin_dec'                     => 'Управление правами доступа в админ панель',
    'blocks_desc'                   => 'Управление блоками, создание, удаление, перемещение',
    'cat_desc'                      => 'Управление категориями, подкатегориями – модулей',
    'conf_desc'                     => 'Общие конфигурации системы',
    'db_desc'                       => 'Инструменты управления базой данных',
    'groups_desc'                   => 'Управление пользовательскими группами сайта',
    'modules_desc'                  => 'Управление модулями системы, установка, удаление, отключение',
    'rss_chenal_desc'               => 'Управление RSS каналами сайта',
    'sendmail_desc'                 => 'Инструменты рассылки сообщений',
    'users_desc'                    => 'Управление пользователями сайта',
    'desc_pages'                    => 'Модуль создания и ведения статей на Вашем сайте.',
    'filrer_referer'                => 'Активировать фильтрацию REFERER-a',
    'filrer_referer_d'              => 'Данная опция будет блокировать все POST запросы, отправленные с других сайтов',
    'language_conf'                 => 'Языковые файлы',
    'language_donf_desc'            => 'Редактирование языковых файлов',
    'desc_shop'                     => 'Модуль организации магазина на вашем сайте.',
    'desc_forum'                    => 'Модуль проведения он-лайн конференций.',
    'forum_desc'                    => 'Описание форума',
    'user_lang'                     => 'Пользовательский файл',
    'vari'                          => 'Переменная',
    'vari_value'                    => 'Значение',
    'name_file'                     => 'Название файла',
    'file_size'                     => 'Размер файла',
    'count_lang'                    => 'Количество слов',
    'info_lang'                     => 'Для возможности редактирования языковых файлов Вам необходимо установить права <b>666</b> на все файлы каталога <b>includes/language/</b> - рекурсивно.',
    'key'                           => 'Ключ',
    'configmenu'                    => 'Меню сайта',
    'configmenu_desc'               => 'Управление блоком навигации',
    'add_row_menu'                  => 'Добавить ссылку',
    'class'                         => 'Класс стилей',
    'errorurl'                      => '<li class="error">Не введен URL!</li>',
    'configmessages'                => 'Сообщения',
    'messages_desc'                 => 'Используется для размещения сообщений на главной странице',
    'add_message'                   => 'Добавить сообщение',
    'enabled'                       => 'Включить',
    'error_message'                 => '<li class="error">Не введено сообщение!</li>',
    'search_modules'                => 'Поиск модулей',
    'install'                       => 'Установить',
    'block_status'                  => 'Отображение блоков в модуле',
    'only_left_block'               => 'Активировать только левые блоки',
    'only_right_block'              => 'Активировать только правые блоки',
    'all_block'                     => 'Активировать левые и правые блоки',
    'disabled_all_block'            => 'Деактивировать левые и правые блоки',
    'access_module'                 => 'Имеют доступ',
    'add_user'                      => 'Создать пользователя',
    'search_user'                   => 'Найти пользователя',
    'newpassword'                   => 'Новый пароль',
    'allregister'                   => 'Стандартная регистрация',
    'emailregister'                 => 'Регистрация с подтверждением E-mail',
    'adminregister'                 => 'Регистрация с проверкой администрации',
    'noregister'                    => 'Отключить регистрацию',
    'directory_avatar'              => 'Каталог для аватар',
    'directory_avatar_d'            => 'Директория для хранения загруженных аватар',
    'registration_c'                => 'Тип регистрации на сайте',
    'registration_c_d'              => 'Выберете сценарий регистрации пользователей на сайте',
    'guest_name'                    => 'Имя гостей',
    'guest_name_d'                  => 'Выводимое имя для неавторизированных пользователей',
    'size_avatar'                   => 'Максимальный размер аватары',
    'width_avatar'                  => 'Максимальная ширина аватары',
    'height_avatar'                 => 'Максимальная высота аватары',
    'type_avatar'                   => 'Типы загружаемых аватар',
    'password_length'               => 'Длина пароля',
    'default_group'                 => 'Группа по умолчанию',
    'enabled_load_avatar'           => 'Разрешить загрузку аватар',
    'load_avatar_d'                 => 'Разрешить пользователям загружать собственные аватары',
    'attachingpm_d'                 => 'Разрешить пользователям прикреплять файлы к ПМ',
    'novalidcatparametr'            => '<li class="error">Не правильно задан параметр категории</li>',
    'cat_cols'                      => 'В сколько столбцов отображать категории',
    'cat_cols_d'                    => 'Количество столбцов для вывода категорий в модуле',
    'clasic_cat'                    => 'Активировать классический вывод категорий',
    'clasic_cat_d'                  => 'Использовать вложенный вывод категорий (как в Kasseler CMS 1.x.x)',
    'download_resume'               => 'Включить дозагрузку файлов при скачивании',
    'download_speed'                => 'Максимальная скорость загрузки',
    'download_resume_d'             => 'Вы можете разрешить или запретить использование дозагрузки файлов для ваших пользователей, если произошел разрыв соединения при скачивании.',
    'download_speed_d'              => 'Вы можете ограничить максимальную скорость загрузки файла kb/s.',
    'log_emeail'                    => 'Включить log отправки сообщений',
    'log_emeail_d'                  => 'При включенном log-e сообщений в каталоге uploads/log/mails/ будут создаваться *.eml файлы',
    'mail_is_html'                  => 'Способ отправки сообщений',
    'mail_is_html_d'                => 'Выберете формат отправляемых сообщений',
    'contact_mail'                  => 'E-mail адрес обратной связи',
    'contact_mail_d'                => 'Введите E-mail адрес, куда будут приходить все сообщения, отправленные с модуля "Обратная связь"',
    'sends_mail'                    => 'E-mail адрес рассылки',
    'sends_mail_d'                  => 'Введите E-mail адрес отправителя рассылки',
    'charset_mail'                  => 'Кодировка E-mail сообщений',
    'charset_mail_d'                => 'Введите кодировку отправляемых E-mail сообщений',
    'bcc_send'                      => 'Использовать поле BCC для рассылки',
    'bcc_send_d'                    => 'Если вы активируете опцию, то при рассылке сообщений в качестве получателей будет указано несколько адресатов, что позволяет сократить общее время отправки сообщений и количество отправленных сообщений.',
    'type_email_send'               => 'Метод отправки почты',
    'type_email_send_d'             => 'Если функция mail() недоступна, выберите метод SMTP',
    'smtp_host'                     => 'SMTP хост',
    'smtp_port'                     => 'SMTP Порт',
    'smtp_user'                     => 'SMTP Имя пользователя',
    'smtp_password'                 => 'SMTP Пароль',
    'smtp_host_d'                   => 'Адрес SMTP сервера',
    'smtp_port_d'                   => 'Порт SMTP сервера',
    'smtp_user_d'                   => 'Пользователь SMTP сервера',
    'smtp_password_d'               => 'Пароль SMTP сервера',
    'post_report_pat'               => 'Шаблон жалобы на сообщение форума',
    'post_report_pat_d'             => 'Сообщение жалобы пользователя.<br />{SITE} - ссылка на сайт<br />{USER} - логин пользователя<br />{TOPIC} – ссылка на тему форума<br />{POST} – ссылка на сообщение форума',
    'new_pm_pat'                    => 'Шаблон уведомления о получении ЛС',
    'new_pm_pat_d'                  => 'Сообщение отправляется получателю на E-mail.<br />{SITE} - ссылка на сайт<br />{USER} - логин пользователя<br />{SUBJECT} – тема сообщения<br />{SENDER} – отправитель сообщения<br />{URL} – ссылка для переходя к сообщению',
    'new_password_pat'              => 'Шаблон запроса на восстановление пароля',
    'new_password_pat_d'            => 'Сообщение отправляется на E-mail запросившему пользователю.<br />{SITE} - ссылка на сайт<br />{USER} - логин пользователя<br />{CODE} – ссылка на форму смены пароля',
    'save_newpassword_pat'          => 'Шаблон уведомления о новом пароле',
    'save_newpassword_pat_d'        => 'Напоминающее сообщение, что была произведена смена пароля.<br />{SITE} - ссылка на сайт<br />{USER} - логин пользователя<br />{PASSWORD} – новый пароль пользователя',
    'browsers_statistic'            => 'Статистика браузеров',
    'other_browsers'                => 'Неизвестные браузеры',
    'os_statistic'                  => 'Статистика операционных систем пользователей',
    'other_os'                      => 'Неизвестная ОС',
    'user_id'                       => 'Идентификатор пользователя',
    'case_language_site'            => 'Язык сайта',
    'case_template_site'            => 'Шаблон сайта',
    'adm_viewemail'                 => 'Показывать E-mail адрес',
    'adm_user_pm_send'              => 'Уведомить при получении ЛС',
    'adm_you_avatar'                => 'Аватара пользователя',
    'adm_load_avatar'               => 'Загрузить аватару',
    'case_groups'                   => 'Участник групп',
    'download_guest'                => 'Разрешить загрузку файлов для гостей',
    'download_guest_d'              => 'Опция запрещает/разрешает гостям скачивать файлы',
    'all_users'                     => 'Все пользователи',
    'only_users'                    => 'Только пользователи',
    'only_moder'                    => 'Только модераторы',
    'only_admin'                    => 'Только администраторы',
    'all'                           => 'Все',
    'ip'                            => 'IP адрес',
    'user_agent_full'               => 'Использовать расширенную статистику',
    'user_agent_full_d'             => 'Данная функция позволяет более подробно определять операционные системы и браузеры пользователей',
    'add_group'                     => 'Добавить группу',
    'points_for_group'              => 'Пунктов',
    'user_in_group'                 => 'Участников',
    'is_special_group'              => 'Специальная',
    'show_user_in_group'            => 'Просмотреть пользователей этой группы',
    'color_group'                   => 'Цвет группы',
    'name_group_error'              => '<li class="error">Не введено название группы!</li>',
    'points_conf'                   => 'Пункты',
    'limit'                         => 'Лимит',
    'status_on'                     => '<span style="color: green;">Актив.</span>',
    'status_off'                    => '<span style="color: red;">Не актив.</span>',
    'optimization_db'               => '<b>Оптимизация базы данных</b>',
    'optimization_db_d'             => 'Функция выполняет оптимизацию таблиц базы данных, чем уменьшает их размер.',
    'repair_db'                     => '<b>Ремонт базы данных</b>',
    'repair_db_d'                   => 'При неожиданных сбоях в СУБД, может произойти повреждение структуры таблиц базы данных, данная функция попытается их восстановить.',
    'run'                           => 'Выполнить',
    'backup_db'                     => 'Резервное копирование',
    'sql_db'                        => 'SQL менеджер',
    'name_table'                    => 'Название таблицы',
    'size_table'                    => 'Размер таблицы',
    'end_size_table'                => 'Размер после оптимизации',
    'optimize_table'                => 'Оптимизировано',
    'rows_table'                    => 'Записей',
    'all_size_table'                => 'Общий размер таблиц',
    'status_error'                  => 'Ошибка',
    'status_ok'                     => 'Успешно',
    'backup_db2'                    => '<b>Создание резервной копии БД</b>',
    'restore_db'                    => '<b>Загрузка резервной копии с диска</b>',
    'list_table_backup'             => 'Список таблиц для резервного копирования',
    'time_backuper'                 => 'Время выполнения',
    'sizes'                         => 'Размер',
    'create_date'                   => 'Дата создания',
    'update_date'                   => 'Дата модификации',
    'type_table'                    => 'Тип',
    'charset_db'                    => 'Кодировка',
    'field'                         => 'Поле',
    'type_col'                      => 'Тип поля',
    'key_col'                       => 'Ключ',
    'default_col'                   => 'Значение по умолчанию',
    'extra_col'                     => 'Дополнительно',
    'insert'                        => 'Вставить',
    'clear'                         => 'Очистка',
    'successful_sql'                => 'Запрос успешно выполнен, обработано {COUNT} полей.',
    'successful_sql2'               => 'Запрос успешно выполнен.',
    'page_list'                     => 'Перейти на страницу',
    'run_request'                   => 'Выполнить запрос',
    'struct_table'                  => 'Просмотр структуры',
    'realy_clear'                   => 'Вы действительно хотите очистить таблицу?',
    'show_query'                    => 'Просмотр данных',
    'structure'                     => 'Структура',
    'level_type'                    => 'Статус',
    'administrator'                 => '<span style="color: red;">Администратор</span>',
    'moderator'                     => '<span style="color: green;">Модератор</span>',
    'add_support'                   => 'Добавить пользователя',
    'access_modules'                => 'Доступ к модулям',
    'ad_admin'                      => 'Права доступа',
    'ad_blocks'                     => 'Блоки и баннеры',
    'ad_categories'                 => 'Категории',
    'ad_config'                     => 'Конфигурация',
    'ad_database'                   => 'База данных',
    'ad_groups'                     => 'Группы',
    'ad_language'                   => 'Языковые файлы',
    'ad_menu'                       => 'Меню сайта',
    'ad_messages'                   => 'Сообщения',
    'ad_moduleslist'                => 'Модули',
    'ad_phpinfo'                    => 'Информация о сервере',
    'ad_rss'                        => 'RSS каналы',
    'ad_sendmail'                   => 'Рассылка',
    'ad_statistic'                  => 'Статистика',
    'ad_users'                      => 'Пользователи',
    'ad_management'                 => 'Список модулей управления',
    'ad_modules'                    => 'Список пользовательских модулей',
    'administration_modules'        => 'Администрирование',
    'moderation_module'             => 'Модерирование',
    'admin_module_list'             => 'Список доступных модулей',
    'home_module_list'              => 'Список активных модулей',
    'error_load_amin_module'        => 'Существует проблема загрузки одного из модулей админ панели, пожалуйста, проверьте  конфигурацию.',
    'add_shop'                      => 'Добавить товар',
    'price'                         => 'Цена',
    'form_config'                   => 'Конфигурация формы',
    'new_forum'                     => 'Создать новый форум',
    'new_forum_cat'                 => 'Создать новую категорию',
    'optimize_db'                   => 'Оптимизация и ремонт БД',
    'visite_kasseler'               => 'Посетить официальный сайт',
    'install_stat'                  => 'Просмотреть статистику установок',
    'change_chmod'                  => 'Изменить chmod',
    'mod_date'                      => 'Дата модификации',
    'copy'                          => 'Копировать',
    'paste'                         => 'Вставить',
    'file_is_copied'                => 'Файл скопирован!',
    'enter_octal_number'            => 'Введите восьмеричное число',
    'changing_access_rights'        => 'Изменение прав доступа',
    'owner'                         => 'Владелец',
    'others'                        => 'Остальные',
    'numeric_chmod'                 => 'Числовой формат записи chmod',
    'reading'                       => 'чтение',
    'record'                        => 'запись',
    'execution'                     => 'выполнение',
    'error_copy'                    => 'Буфер пуст',
    'newfile'                       => 'Создать новый файл',
    'input_filename'                => 'Введите название нового файла',
    'file_exists'                   => 'Файл с таким именем уже существует',
    'input_fildername'              => 'Введите название каталога',
    'folder_exists'                 => 'Файл или каталог с таким именем уже существует.',
    'is_writable'                   => '<span style="color: green;">Доступен для записи</span>',
    'is_not_writable'               => '<span style="color: red;">Не доступен для записи</span>',
    'newfolder'                     => 'Создать новый каталог',
    'upload_file'                   => 'Загрузить файлы',
    'file_is_not_writable'          => '<li class="error">Ошибка! Файл или каталог недоступен для записи.</li>',
    'file_is_notfound'              => '<li class="error">Ошибка! Файл или каталог не найден.</li>',
    'error_chmod_set'               => '<li class="error">Ошибка установки атрибутов файла или каталога.</li>',
    'error_chmod_func'              => '<li class="error">Неизвестная ошибка! Права доступа к файлу или каталогу не установлены.</li>',
    'file'                          => 'Файл',
    'moder_error'                   => '<li class="error">Доступ запрещен!</li>',
    'admin_error'                   => '<li class="error">У вас нет доступа к данному разделу админ панели!</li>',
    'ad_filemanager'                => 'Файловый менеджер',
    'ad_comments'                   => 'Комментарии',
    'comments_desc'                 => 'Просмотр пользовательских комментариев',
    'ad_attach'                     => 'Прикрепленные файлы',
    'attach_desc'                   => 'Просмотр прикрепленных файлов',
    'ad_pm'                         => 'Личные сообщения',
    'pm_desc'                       => 'Просмотр личных сообщений пользователей',
    'security_desc'                 => 'Управление безопасностью системы',
    'filemanager_desc'              => 'Менеджер файловой системы',
    'guest_comments_status'         => 'Доступно для гостей',
    'delete_tmp_dir'                => 'Удалить временные каталоги',
    'ad_private_message'            => 'Личные сообщения',
    'site_show'                     => 'Просмотр сайта',
    'desc_voting'                   => 'Модуль организации опросов для посетителей сайта.',
    'desc_search'                   => 'Модуль поиска по сайту.',
    'desc_oline_radio'              => 'Модуль создания онлайн радио на Вашем сайте.',
    'content_replace'               => 'Автозамены',
    'phplogs'                       => 'Ошибки PHP',
    'sqllogs'                       => 'Ошибки SQL',
    'httplogs'                      => 'Ошибки HTTP',
    'loginedlogs'                   => 'Ошибки авторизации',
    'center_forum'                  => 'Последние сообщения форума',
    'shopping_cart'                 => 'Корзина',
    'user_menu'                     => 'Меню пользователя',
    'top5_files'                    => 'Топ5 файлов',
    'voting_random'                 => 'Случайный опрос',
    'line'                          => 'Строка',
    'error'                         => 'Ошибка',
    'page'                          => 'Страница',
    'code_error'                    => 'Код ошибки',
    'query_string'                  => 'SQL запрос',
    'size_avatar_d'                 => 'Максимально допустимый размер, аватары, который может загрузить пользователь',
    'width_avatar_d'                => 'Максимально допустимая ширина аватары, загружаемой пользователями',
    'height_avatar_d'               => 'Максимально допустимая высота аватары, загружаемой пользователями',
    'type_avatar_d'                 => 'Типы изображений которые могут быть загружены как аватара',
    'password_length_d'             => 'Минимальная длина пользовательского пароля',
    'default_group_d'               => 'Присваиваемая группа при регистрации пользователя',
    'enabled_load_avatar_d'         => 'Активирует/деактивирует возможность загрузки пользовательских аватар.',
    'clear_rating_site'             => 'Обнулить статистику сайтов',
    'favorite_page_status'          => 'Активировать страницу закладок',
    'favorite_page_status_d'        => 'Опция активирует/деактивирует просмотр закладок в модуле',
    'favorite_status'               => 'Активировать закладки',
    'favorite_status_d'             => 'Опция активирует/деактивирует возможность использования закладок в модуле',
    'whois_servoce'                 => 'Whois',
    'whois_servoce_d'               => 'Ссылка на сервис Whois',
    'tags_page_status'              => 'Активировать страницу тегов',
    'tags_page_status_d'            => 'Опция активирует/деактивирует страницу всех тегов для модуля',
    'tags_status'                   => 'Активировать теги для модуля',
    'tags_status_d'                 => 'Разрешает/запрещает использование тегов в модуле',
    'compatibility'                 => 'Совместимость',
    'nocompatibility'               => 'Без интеграции',
    'compatibility_d'               => 'Даная опция выполняет интеграцию указанного приложения',
    'sitemap'                       => 'Sitemap генератор',
    'sitemap_desc'                  => 'Автоматическая генерация файла sitemap.xml',
    'always'                        => 'Всегда',
    'hourly'                        => 'Ежечасно',
    'daily'                         => 'Ежедневно',
    'weekly'                        => 'Еженедельно',
    'monthly'                       => 'Ежемесячно',
    'yearly'                        => 'Ежегодно',
    'never'                         => 'Никогда',
    'alles'                         => 'Всего',
    'priority'                      => 'Приоритет',
    'changefreq'                    => 'Обновление',
    'all_link'                      => 'Ссылок',
    'create_sitemap'                => 'Создать sitemap',
    'mess_sitemap'                  => 'Файла <b>sitemap.xml</b> не существует !',
    'monitor_last_robot'            => 'Список недавно посетивших роботов',
    'monitor_last_user'             => 'Список недавно посетивших пользователей',
    'monitor_online'                => 'Мониторинг пользователей online',
    'top5_news'                     => 'Топ5 новостей',
    'top5_users'                    => 'Топ5 пользователей',
    'tags_audio'                    => 'Теги для модуля Аудио',
    'tags_files'                    => 'Теги для модуля Файлы',
    'tags_media'                    => 'Теги для модуля Media',
    'tags_news'                     => 'Теги для модуля Новости',
    'tags_pages'                    => 'Теги для модуля Статьи',
    'last_news'                     => 'Последние новости',
    'last_files'                    => 'Последние файлы',
    'last_voting'                   => 'Последние опросы',
    'last_jokes'                    => 'Последние анекдоты',
    'desc_audio'                    => 'Модуль для публикаций пользовательских аудио записей',
    'in_replace'                    => 'Входящее слово',
    'out_replace'                   => 'Исходящее слово',
    'addblockedip'                  => 'Заблокировать IP',
    'baner_url'                     => 'Банер сайта',
    'baner_url_d'                   => 'Ссылка на мнер сайта',
    'top5_sites'                    => 'Топ5 сайтов',
    'must'                          => 'Обязательное поле',
    'default_value'                 => 'Значение по умолчанию',
    'activate'                      => 'Активировать',
    'deactivate'                    => 'Деактивировать',
    'case_value'                    => 'Варианты выбора',
);                          
?>