<?php
/**
* Основной пользовательский файл системы
* 
* @author Igor Ognichenko
* @copyright Copyright (c)2007-2009 by Kasseler CMS
* @link http://www.kr-cms.net/
* @filesource index.php
* @version 2.0
*/
define('KASSELERCMS', true);

require_once "base.php";
require_once "includes/function/xining.php";
require_once "includes/function/init.php";

global $version_sys, $license_sys, $main;
if(isset($_GET['system'])){ 
    require_once "includes/nocache.php";
    switch($_GET['system']){
        case 'version': echo "VERSION SYSTEM: ".$version_sys." "; break;
        case 'license': echo "LICENSE SYSTEM: ".$license_sys." "; break;
        case 'diff': echo "Diff SYSTEM: 453 "; break;
        case 'sitemap': require_once "includes/function/sitemap.php";  break;
    }
    exit;
}

if(!isset($_GET['ajaxed'])){
    if(!isset($_GET['blockfile'])){    
        $contents = $template->tpl_create(true);
        $contents .= (is_admin() OR is_moder()) ? $tpl_create->generate_info_insert($geterate_time->stop(), $main->db->total_time_db, $main->db->num_queries, strlen($contents), strlen(gzcompress($contents, $main->config['gzlevel']))) : "";
        require_once "includes/nocache.php";
        gz(replace_link(replace_content($contents)));
    } elseif(kr_file_exists("blocks/{$_GET['blockfile']}")) require_once "blocks/{$_GET['blockfile']}";
} else {
    if(!isset($_SERVER["HTTP_REFERER"]) OR empty($_SERVER["HTTP_REFERER"])) {
        header("Location: http://".get_host_name()."");
        exit;
    } else require_once "includes/function/ajax.php";
}
?>